Attribute VB_Name = "modArt"
Type PicType
Pixels() As Byte
End Type

Type tpArtFile
Filename As String
Version As Long
NumTiles As Long
LocalStart As Long
LocalEnd As Long
XSizes() As Integer
YSizes() As Integer
Properties() As Long
PicData() As PicType
ArtNum As Byte
End Type

Public ArtFile As tpArtFile

Public Sub OpenArt(File As String)
'On Error GoTo err
Dim strTemp As String
Dim lnTemp As Long
Dim tByte As Byte
Dim i As Integer
Dim o As Integer
Dim p As Integer
Dim TOffset As Long


CurrTile = 0
OffsetX = 0
OffsetY = 0
Form1.Label1.Caption = "Loading " & File & "..."
DoEvents
With ArtFile
o = -1

'Check where the last slash is in the filename, and store that pos in I.
Do Until o = 0
If o = -1 Then o = 0
i = o
o = InStr(o + 1, File, "\")

Loop

'The art file's number is the last three characters of the 8. in the filename.
.ArtNum = Val(Right(Left(Right(File, Len(File) - i), 8), 3))

'Open an ART file.
Open File For Binary As #1

'ART Header processing.
Get (1), , .Version 'Get a long containing the version number.
Get (1), , lnTemp 'Skip the (outdated) file NumTiles value.
Get (1), , .LocalStart 'Get the start tile.
Get (1), , .LocalEnd 'End tile.
.NumTiles = .LocalEnd - .LocalStart + 1

ReDim .XSizes(.NumTiles)
ReDim .YSizes(.NumTiles)
ReDim .Properties(.NumTiles)
ReDim .PicData(.NumTiles)

'Read the X sizes of the tiles.
For i = 1 To .NumTiles
Get (1), , .XSizes(i)
Next i

'Read the Y sizes of the tiles.
For i = 1 To .NumTiles
Get (1), , .YSizes(i)
Next i

'Read the tile properties.
For i = 1 To .NumTiles
Get (1), , .Properties(i)
Next i

'ART raw data processing.

For i = 1 To .NumTiles
ReDim .PicData(i).Pixels(.XSizes(i), .YSizes(i))
For o = 1 To .XSizes(i)
For p = 1 To .YSizes(i)
Get #1, , .PicData(i).Pixels(o, p)
Next p
Next o
Next i

Close #1

.Filename = File

End With
Form1.Caption = "ARTist - " & File
Form1.mnuSave.Enabled = True
FillBrowser
CurrTile = 1
RenderTile (1)
Exit Sub
err:
If FreeFile > 1 Then Close #1
MsgBox "Error opening ART file.", vbOKOnly + vbExclamation, "ARTist"
NewArt
End Sub

Public Sub SaveArt(File As String, Optional JustSave As Boolean)
'Write an ART file.

If JustSave = True Then
'If not saving as, but just saving, always overwrite the old file.
Kill File
Else
If Overwrite(File) = False Then Exit Sub
End If

Form1.Label1.Caption = "Writing " & File & "..."
DoEvents

Dim i As Integer
Dim o As Integer
Dim p As Integer

Open File For Binary As #1
Put #1, , ArtFile.Version
Put #1, , ArtFile.NumTiles
Put #1, , ArtFile.LocalStart
Put #1, , ArtFile.LocalEnd
For i = 1 To ArtFile.NumTiles
Put #1, , ArtFile.XSizes(i)
Next i
For i = 1 To ArtFile.NumTiles
Put #1, , ArtFile.YSizes(i)
Next i
For i = 1 To ArtFile.NumTiles
Put #1, , ArtFile.Properties(i)
Next i
For i = 1 To ArtFile.NumTiles
For p = 1 To ArtFile.XSizes(i)
For o = 1 To ArtFile.YSizes(i)
Put #1, , ArtFile.PicData(i).Pixels(p, o)
Next o
Next p
Next i
Close #1
Form1.Label1.Caption = "Done."

'So the name updates when saving as.
Form1.mnuSave.Enabled = True
ArtFile.Filename = File
Form1.Caption = "ARTist - " & File
End Sub

Public Sub NewArt()
Form1.mnuSave.Enabled = False
Form1.Picture1.Cls
CurrTile = 0
ArtFile.LocalStart = 0
ArtFile.LocalEnd = 255
ArtFile.NumTiles = 0
ReDim ArtFile.XSizes(0)
ReDim ArtFile.YSizes(0)
ReDim ArtFile.Properties(0)
ReDim ArtFile.PicData(0)
End Sub

Public Sub AddTile(sizex As Integer, sizey As Integer, Properties As Long)

ArtFile.NumTiles = ArtFile.NumTiles + 1
ArtFile.LocalEnd = ArtFile.LocalEnd + 1

ReDim Preserve ArtFile.XSizes(ArtFile.NumTiles)
ReDim Preserve ArtFile.PicData(ArtFile.NumTiles)
ReDim Preserve ArtFile.YSizes(ArtFile.NumTiles)
ReDim Preserve ArtFile.Properties(ArtFile.NumTiles)


ArtFile.XSizes(ArtFile.NumTiles) = sizex
ArtFile.YSizes(ArtFile.NumTiles) = sizey
ArtFile.Properties(ArtFile.NumTiles) = Properties

End Sub
